ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.40 by root, Sun May 1 07:56:26 2011 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
11MAKE=make 12MAKE=make
12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice 13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
13PERL_CC=cc 14PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 18
18ARCH="$(uname -m)" 19ARCH="$(uname -m)"
19 20
20case "$ARCH" in 21#case "$ARCH" in
21 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
23 case "$ARCH" in 24# case "$ARCH" in
24 i*86 ) 25# i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 27# ;;
27 esac 28# esac
28 ;; 29# ;;
29esac 30#esac
30 31
31# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
37 38
38# some configuration options for modules 39# some configuration options for modules
39PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS=" 41PERL_MM_OPT="MAN1PODS= MAN3PODS="
41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS 44export PERL_MM_USE_DEFAULT PERL_MM_OPT
44 45
45# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
46# required by mkbundle 47# required by mkbundle
47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
48 49
49# which extra modules you might want to install 50# which extra modules you might want to install
50EXTRA_MODULES="" 51EXTRA_MODULES=""
51 52
52# overridable functions 53# overridable functions
53preconfigure() { : ; } 54preconfigure() { : ; }
54patchconfig() { : ; } 55patchconfig() { : ; }
55postconfigure() { : ; } 56postconfigure() { : ; }
56postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
57postinstall() { : ; } 59postinstall() { : ; }
58 60
59# now source user config, if any 61# now source user config, if any
60if [ "$STATICPERLRC" ]; then 62if [ "$STATICPERLRC" ]; then
61 . "$STATICPERLRC" 63 . "$STATICPERLRC"
62else 64else
66fi 68fi
67 69
68############################################################################# 70#############################################################################
69# support 71# support
70 72
73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
72 81
73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT 83unset PERL_MB_OPT
75LC_ALL=C; export LC_ALL # just to be on the safe side 84LC_ALL=C; export LC_ALL # just to be on the safe side
78# life easier when working in e.g. "staticperl cpan / look" 87# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH" 88PATH="$PERL_PREFIX/perl/bin:$PATH"
80 89
81# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
82VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
83$VERSION="1.21" 92$VERSION="1.46"
84
85BZ2=bz2
86BZIP2=bzip2
87 93
88fatal() { 94fatal() {
89 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
90 exit 1 96 exit 1
91} 97}
131 137
132############################################################################# 138#############################################################################
133# download/configure/compile/install perl 139# download/configure/compile/install perl
134 140
135clean() { 141clean() {
136 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
137} 143}
138 144
139realclean() { 145realclean() {
140 rm -f "$PERL_PREFIX/staticstamp.postinstall" 146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
141 rm -f "$PERL_PREFIX/staticstamp.install" 147 rm -f "$PERL_PREFIX/staticstamp.install"
142 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure" 148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
143} 149}
144 150
145fetch() { 151fetch() {
152(
146 rcd "$STATICPERL" 153 rcd "$STATICPERL"
147 154
148 mkdir -p src 155 mkdir -p src
149 rcd src 156 rcd src
150 157
151 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
152 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
153 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
154 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
155 181
182 if ! [ -e "$PERLTAR" ]; then
156 verblock <<EOF 183 verblock <<EOF
157downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
158to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
160trying $URL
161EOF
162 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
166 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
167 rm -f perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
169 fi 210 fi
170 211
171 verblock <<EOF 212 verblock <<EOF
172unpacking perl 213unpacking perl
173EOF 214EOF
174 215
175 mkdir -p unpack 216 case "$PERLTAR" in
176 rm -rf unpack/perl-$PERL_VERSION 217 *.xz ) UNCOMPRESS="xz -d" ;;
177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \ 218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
179 chmod -R u+w unpack/perl-$PERL_VERSION 230
180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
181 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
182 fi 240 fi
241) || exit
183} 242}
184 243
185# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
186sedreplace() { 245sedreplace() {
187 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
214EOF 273EOF
215 exit 1 274 exit 1
216} 275}
217 276
218configure() { 277configure() {
278(
219 fetch 279 fetch
220 280
221 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
222 282
223 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
224 284
225 verblock <<EOF 285 verblock <<EOF
226configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
227EOF 287EOF
228 288
229 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
230 290
231 "$MAKE" distclean >/dev/null 2>&1 291 "$MAKE" distclean >/dev/null 2>&1
273 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
274 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
275 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
276 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
277 -Duseperlio \ 337 -Duseperlio \
338 -Uversiononly \
278 -dE || configure_failure 339 -dE || configure_failure
279 340
280 sedreplace ' 341 sedreplace '
281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
282 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
286 347
287 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
288 349
289 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
290 351
291 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
292} 354}
293 355
294write_shellscript() { 356write_shellscript() {
295 { 357 {
296 echo "#!/bin/sh" 358 echo "#!/bin/sh"
301 } >"$PERL_PREFIX/bin/$1" 363 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1" 364 chmod 755 "$PERL_PREFIX/bin/$1"
303} 365}
304 366
305build() { 367build() {
368(
306 configure 369 configure
307 370
308 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
309 372
310 verblock <<EOF 373 verblock <<EOF
311building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
312EOF 375EOF
313 376
314 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
315 378
316 "$MAKE" || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
317 380
318 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
319} 395}
320 396
321install() { 397install() {
398(
322 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
323 build 400 build
324 401
325 verblock <<EOF 402 verblock <<EOF
326installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
327to $PERL_PREFIX 404to $PERL_PREFIX
328EOF 405EOF
329 406
330 ln -sf "perl/bin/" "$STATICPERL/bin" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
331 ln -sf "perl/lib/" "$STATICPERL/lib" 408 ln -sf "perl/lib/" "$STATICPERL/lib"
333 mkdir "$STATICPERL/patched" 410 mkdir "$STATICPERL/patched"
334 411
335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
336 rm -rf "$PERL_PREFIX" # by this rm -rf 413 rm -rf "$PERL_PREFIX" # by this rm -rf
337 414
415 rcd "$STATICPERL/src/perl"
416
338 "$MAKE" install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
339 418
340 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
341 420
342 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
343 write_shellscript SP-make-install-make <<'EOF' 422 write_shellscript SP-make-make <<'end_of_make'
423#CAT make-make.sh
424end_of_make
425
426 # create a "make install" replacement for CPAN
427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
344#CAT make-install-make.sh 428#CAT make-install-make.sh
345EOF 429end_of_make_install_make
346 430
347 # create a "patch modules" helper 431 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF' 432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
349#CAT patch-postinstall.sh 433#CAT patch-postinstall.sh
350EOF 434end_of_patch_postinstall
351 435
436 # immediately use it
352 "$PERL_PREFIX/bin/SP-patch-postinstall" 437 "$PERL_PREFIX/bin/SP-patch-postinstall"
353 438
354 # help to trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
356 441
357 # we call cpan with -MCPAN::MyConfig in this script, which 442 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway, 443 # is strictly unnecessary as we have to patch CPAN anyway,
359 # so consider it "for good measure". 444 # so consider it "for good measure".
360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
363 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM"); 462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
373 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
374 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
375 465
466 postcpanconfig
467
376 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
377 fi 469 fi
378 470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
379 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
380 NOCHECK_INSTALL=+ 482 verblock <<EOF
381 instcpan $STATICPERL_MODULES 483import perl from $IMPORT to $STATICPERL
382 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 484EOF
383 485
384 postinstall || fatal "postinstall hook failed" 486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
385 490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
386 touch "$PERL_PREFIX/staticstamp.postinstall" 493 : > "$PERL_PREFIX/staticstamp.install"
387 fi 494 fi
495
496 _postinstall
497) || exit
388} 498}
389 499
390############################################################################# 500#############################################################################
391# install a module from CPAN 501# install a module from CPAN
392 502
393instcpan() { 503instcpan() {
394 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
395 505
396 verblock <<EOF 506 verblock <<EOF
397installing modules from CPAN 507installing modules from CPAN
398$@ 508$*
399EOF 509EOF
400 510
401 for mod in "$@"; do 511 MYCONFIG=
402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
403 || fatal "$mod: unable to install from CPAN" 513
404 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
405 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
406} 520}
407 521
408############################################################################# 522#############################################################################
409# install a module from unpacked sources 523# install a module from unpacked sources
410 524
411instsrc() { 525instsrc() {
412 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
413 527
414 verblock <<EOF 528 verblock <<EOF
415installing modules from source 529installing modules from source
416$@ 530$*
417EOF 531EOF
418 532
419 for mod in "$@"; do 533 for mod in "$@"; do
420 echo 534 echo
421 echo $mod 535 echo $mod
459catmkbundle() { 573catmkbundle() {
460 { 574 {
461 read dummy 575 read dummy
462 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
463 cat 577 cat
464 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
465#CAT mkbundle 579#CAT mkbundle
466MKBUNDLE 580end_of_mkbundle
467} 581}
468 582
469bundle() { 583bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}" 584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
483 command="${1#--}"; shift 597 command="${1#--}"; shift
484 case "$command" in 598 case "$command" in
485 version ) 599 version )
486 echo "staticperl version $VERSION" 600 echo "staticperl version $VERSION"
487 ;; 601 ;;
488 fetch | configure | build | install | clean | realclean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
489 ( "$command" ) || exit 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
490 ;; 608 ;;
491 instsrc ) 609 instsrc )
492 ( instsrc "$@" ) || exit 610 ( instsrc "$@" ) || exit
493 exit 611 exit
494 ;; 612 ;;
501 exec "$PERL_PREFIX/bin/perl" "$@" 619 exec "$PERL_PREFIX/bin/perl" "$@"
502 exit 620 exit
503 ;; 621 ;;
504 cpan ) 622 cpan )
505 ( install ) || exit 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
506 exec "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
507 exit 627 exit
508 ;; 628 ;;
509 mkbundle ) 629 mkbundle )
510 ( install ) || exit 630 ( install ) || exit

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines